/*
 * Copyright (c) 2012-2013 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice and this list of conditions.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice and  this list of  conditions in the  documentation and/or
 *      other materials provided with the distribution.
 *
 *                                      Anthony Mallet on Thu Mar 15 2012
 */
#ifndef H_CCLIENT_PRIVATE
#define H_CCLIENT_PRIVATE

#include <stddef.h>
#include <stdint.h>

#include "csLib.h"

#include "genom3/c/client.h"

struct pocolibs_options {
  size_t varmsg_maxsize;
  char *instance;
};

struct genom_client_s {
  char *instance;
  genom_event error;
  CLIENT_ID csid;

  struct genom_client_request {
    const struct genom_service_info *info;
    int rid, aid;
    int status;
    genom_event report;
    void *output;
    int	(*decode)(char *, int, char *, int);
    genom_request_cb sentcb, donecb;
    void *cb_data;
  } *active_rqst;
  int nactive, next;
};

genom_event	pocolibs_init(size_t mboxsize);
void		pocolibs_fini(void);
genom_event	pocolibs_getopt(int argc, char *argv[],
                        struct pocolibs_options *opts);

int		pocolibs_eventfd(void);
const struct genom_service_info *
		pocolibs_service_info(genom_client h, int rqstid);
genom_event	pocolibs_waitevent(void);
genom_event	pocolibs_waitack(genom_client h, int rqstid);
genom_event	pocolibs_waitterm(genom_client h, int rqstid);
int		pocolibs_done(genom_client h, int rqstid);
genom_event	pocolibs_clean(genom_client h, int rqstid);
genom_event	pocolibs_doevents(genom_client h);

genom_event	pocolibs_newrqst(genom_client h, size_t outsize, int *rqstid);

#endif /* H_CCLIENT_PRIVATE */
